<template>
  <v-card class="mx-auto">
    <v-toolbar color="primary" dark>
      <v-toolbar-title>{{ listTitle }}</v-toolbar-title>
    </v-toolbar>
    <v-list v-if="recipes.length !== 0" three-line>
      <v-list-item v-for="recipe in recipes" :key="recipe.Id" @click="routeToRecipe(recipe.Id)">
        <v-list-item-avatar>
          <v-icon>mdi-silverware</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <router-link :to="{name: 'recipe', params: {id: recipe.Id.toString()}}">
            <v-list-item-title v-html="recipe.Title"></v-list-item-title>
          </router-link>
          <v-list-item-subtitle>
            {{recipe.Comment}}
          </v-list-item-subtitle>
          <v-list-item-subtitle>
            <small>Créé le : {{ recipe.CreationDate | toDisplayDateTime }}</small>
          </v-list-item-subtitle>
        </v-list-item-content>
      </v-list-item>
    </v-list>
    <v-banner sticky v-else>Pas encore de recettes ?
      <template v-slot:actions>
        <v-btn color="secondary" text :to="{name: 'recipe-add'}">
          Ajouter une recette
        </v-btn>
        <v-icon right dark>mdi-account</v-icon>
      </template>
    </v-banner>
  </v-card>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Prop } from "vue-property-decorator";
import Recipe from "../../../transport/Recipe";

@Component
export default class RecipeList extends Vue {
  @Prop({ type: Array, required: true })
  recipes: Recipe[];

  @Prop({ type: String, required: false, default: "Recettes" })
  listTitle: string;
  // Dernières recettes
  routeToRecipe(recipeId: number) {
    this.$router.push({ name: "recipe", params: { id: recipeId.toString() } });
  }
}
</script>
